# Copyright (c) 2004-2007 Bartek Wilczynski and Norbert Dojer; All Rights Reserved.
#
# This software is distributable under the terms of the GNU
# General Public License (GPL) v2, the text of which can be found at
# http://www.gnu.org/copyleft/gpl-2.0.txt. Installing, importing or otherwise
# using this module constitutes acceptance of the terms of this License.
#
# Disclaimer
# 
# This software is provided "as-is".  There are no expressed or implied
# warranties of any kind, including, but not limited to, the warranties
# of merchantability and fittness for a given application.  In no event
# shall Gary Strangman be liable for any direct, indirect, incidental,
# special, exemplary or consequential damages (including, but not limited
# to, loss of use, data or profits, or business interruption) however
# caused and on any theory of liability, whether in contract, strict
# liability or tort (including negligence or otherwise) arising in any way
# out of the use of this software, even if advised of the possibility of
# such damage.
#

import math,stats
from score import score#,score_cont

class BDE(score):
    def __init__(self,n_disc,prior=None):
        score.__init__(self,n_disc)
        self.prior=prior
        self.alpha = 1.0
        #self.H = 1.0
        
    def HP(self,v,par):
        if self.prior==None:
            return max(2,v.n_disc)
        else:
            hp=float(self.prior)
            for p in par:
                hp/=max(2,p.n_disc)
            return hp
    
    def H(self,v,par):
        if self.prior==None:
            return 1.0
        else:
            return self.HP(v,par)/max(2,v.n_disc)
    
    def graph_score(self,n_vert,v,weights,n_data):
        return sum(map(math.log,weights))*self.alpha*math.log(n_data+1)*min(1,v.n_disc+0.1)
        #graph_struct=(1+len(par_disc))*math.log(n_vert,2)
        #graph_cpd=0.5*(n_disc-1)*math.log(n_data,2)
        #for p_disc in par_disc:
        #    graph_cpd*=p_disc
        #return graph_struct+graph_cpd
        
#    def graph_score(self,n_vert,n_par,n_data):
        #s = math.log(1.0 / math.pow(2.0,((1+n_par)*math.log(n_vert,2))))   #
        #s2 = (1+n_par)*math.log(n_vert)#*math.log(self.alpha,2)
        #print -s,s2,s/s2
#        return n_par*self.alpha
    
    def data_min(self,v,data):
        if self.prior!=None:
            return 0.0
        HP=self.HP(v,[])
        H=self.H(v,[])
        sd = self.sel_data(v,[],data)
        stats_all,stats_par = self.stats(sd,v,[])
        #print sd,stats_all,stats_par
        #par_counted = []
        if v.n_disc:
            s = 0 #math.log(self.H)
            for a,cv in stats_all.items():
                #aaa =s
                for i in range(0,cv):
                    #print"xxx",  self.H+i,math.log(self.H+i) #,2),s
                    s-=math.log(H+i) #,2),s
                    s+=math.log(HP+i) #,2)
                #print s-aaa
        else:
            gh = stats.gammln(H)
            s = stats.gammln(HP+stats_par[()])-stats.gammln(HP)
            for a,cv in stats_all.items():
                s+=gh-stats.gammln(H+cv)
        #print -s
        return s*self.data_factor
        
    def data_score(self,v,par,data):
        HP=self.HP(v,par)
        H=self.H(v,par)
        sd = self.sel_data(v,par,data)
        stats_all,stats_par = self.stats(sd,v,par)
        #print sd,stats_all,stats_par
        s = 0 #math.log(self.H)
        if 0 not in map(lambda p: p.n_disc,par+[v]):
            par_counted = []
            for a,cv in stats_all.items():
                par = a[:-1]
                cp = stats_par[par]
                if par not in par_counted:
                    tmp =0
                    for i in range(0,cp):
                        #print "+++", self.H+i,math.log(self.H+i) #,2)
                        tmp+=math.log(HP+i) #,2)
                    s+=tmp
                    #print "---",tmp,s
                    par_counted.append(par)
                    
                #aaa =s
                for i in range(0,cv):
                    #print"xxx",  self.H+i,math.log(self.H+i) #,2),s
                    s-=math.log(H+i) #,2),s
                #print s-aaa
        else:
            gh = stats.gammln(H)
            ghp = stats.gammln(HP)
            for a,cv in stats_all.items():
                s+=gh-stats.gammln(H+cv)
            for a,cp in stats_par.items():
                s+=stats.gammln(HP+cp)-ghp
        #print -s
        return s*self.data_factor

